/* Copyright (c) 2006-2014 Polybus Systems Corp., Westford, MA, USA */

/* All rights reserved. */

/* Redistribution and use in source and binary forms, with or without modification, */
/* are permitted provided that the following conditions are met: */

/* * Redistributions of source code must retain the above copyright notice, this */
/* list of conditions and the following disclaimer. */
/* * Redistributions in binary form must reproduce the above copyright notice, */
/* this list of conditions and the following disclaimer in the documentation */
/* and/or other materials provided with the distribution. */
/* * Neither the name of the Polybus Systems Corp nor the names of its contributors */
/* may be used to endorse or promote products derived from this software */
/* without specific prior written permission. */

/* THIS SOFTWARE IS PROVIDED BY POLYBUS AND CONTRIBUTORS ''AS IS'' AND ANY */
/* EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED */
/* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE */
/* DISCLAIMED. IN NO EVENT SHALL POLYBUS OR CONTRIBUTORS BE LIABLE FOR ANY */
/* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES */
/* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; */
/* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON */
/* ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT */
/* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS */
/* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */

double mmrDoubleSumProd(double *base,SInt64 max,SInt64 length,double fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
double mrDoubleDiv(double *base,SInt64 max,SInt64 length,double fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
double mrDoubleMpy(double *base,SInt64 max,SInt64 length,double fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
double mrDoubleSum(double *base,SInt64 max,SInt64 length,double fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
double mrrDoubleSumProd(double *base,SInt64 max,SInt64 length,double fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
double rrDoubleDiv(SInt64 max,SInt64 length,double fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
double rrDoubleMpy(SInt64 max,SInt64 length,double fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
double rrDoubleSum(SInt64 max,SInt64 length,double fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
float mmrFloatSumProd(float *base,SInt64 max,SInt64 length,float fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
float mrFloatDiv(float *base,SInt64 max,SInt64 length,float fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
float mrFloatMpy(float *base,SInt64 max,SInt64 length,float fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
float mrFloatSum(float *base,SInt64 max,SInt64 length,float fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
float mrrFloatSumProd(float *base,SInt64 max,SInt64 length,float fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
float rrFloatDiv(SInt64 max,SInt64 length,float fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
float rrFloatMpy(SInt64 max,SInt64 length,float fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
float rrFloatSum(SInt64 max,SInt64 length,float fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
long fpDoubleTest(void *base,SInt64 limit,long num,long num_threads,long firsttime,
		  double exp[MAX_SIZES][NUM_FP_TESTS],result fp_rslt[NUM_FP_TESTS][MAX_SIZES],SInt32 vnum,SInt64 time_scale[MAX_SIZES][NUM_FP_TESTS]);
long fpFloatTest(void *base,SInt64 limit,long num,long num_threads,long firsttime,
		 float exp[MAX_SIZES][NUM_FP_TESTS],result fp_rslt[NUM_FP_TESTS][MAX_SIZES],SInt32 vnum,SInt64 time_scale[MAX_SIZES][NUM_FP_TESTS]);
SInt64 numLoops(SInt64 length);
void fillDoubleMem(double *base,SInt64 max,double ivalue[],long words);
void fillFloatMem(float *base,SInt64 max,float ivalue[],long words);
