/* Copyright (c) 2006-2014 Polybus Systems Corp., Westford, MA, USA */

/* All rights reserved. */

/* Redistribution and use in source and binary forms, with or without modification, */
/* are permitted provided that the following conditions are met: */

/* * Redistributions of source code must retain the above copyright notice, this */
/* list of conditions and the following disclaimer. */
/* * Redistributions in binary form must reproduce the above copyright notice, */
/* this list of conditions and the following disclaimer in the documentation */
/* and/or other materials provided with the distribution. */
/* * Neither the name of the Polybus Systems Corp nor the names of its contributors */
/* may be used to endorse or promote products derived from this software */
/* without specific prior written permission. */

/* THIS SOFTWARE IS PROVIDED BY POLYBUS AND CONTRIBUTORS ''AS IS'' AND ANY */
/* EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED */
/* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE */
/* DISCLAIMED. IN NO EVENT SHALL POLYBUS OR CONTRIBUTORS BE LIABLE FOR ANY */
/* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES */
/* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; */
/* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON */
/* ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT */
/* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS */
/* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */

SInt16 mmrSInt16SumProd(SInt16 * base,SInt64 max,SInt64 length,SInt16 fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
SInt16 mrSInt16Div(SInt16 * base,SInt64 max,SInt64 length,SInt16 fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
SInt16 mrSInt16Mpy(SInt16 * base,SInt64 max,SInt64 length,SInt16 fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
SInt16 mrSInt16Sum(SInt16 * base,SInt64 max,SInt64 length,SInt16 fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
SInt16 mrrSInt16SumProd(SInt16 * base,SInt64 max,SInt64 length,SInt16 fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
SInt16 rrSInt16Div(SInt16 max,SInt64 length,SInt16 fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
SInt16 rrSInt16Mpy(SInt16 max,SInt64 length,SInt16 fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
SInt16 rrSInt16Sum(SInt64 max,SInt64 length,SInt16 fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
SInt32 intLongTest(void *base,SInt64 limit,SInt32 num,SInt32 num_threads,SInt32 firsttime,
		   SInt32 exp[32][NUM_FP_TESTS],result rslt[NUM_FP_TESTS][MAX_SIZES],SInt32 vnum,SInt64 time_scale[MAX_SIZES][NUM_FP_TESTS]);
SInt32 intSInt16Test(void *base,SInt64 limit,SInt32 num,SInt32 num_threads,SInt32 firsttime,
		     SInt16 exp[32][NUM_FP_TESTS],result rslt[NUM_FP_TESTS][MAX_SIZES],SInt32 vnum,SInt64 time_scale[MAX_SIZES][NUM_FP_TESTS]);
SInt32 intSInt64Test(void *base,SInt64 limit,SInt32 num,SInt32 num_threads,SInt32 firsttime,
		     SInt64 exp[32][NUM_FP_TESTS],result rslt[NUM_FP_TESTS][MAX_SIZES],SInt32 vnum,SInt64 time_scale[MAX_SIZES][NUM_FP_TESTS]);
SInt32 mmrLongSumProd(SInt32 *base,SInt64 max,SInt64 length,SInt32 fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
SInt32 mrLongDiv(SInt32 *base,SInt64 max,SInt64 length,SInt32 fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
SInt32 mrLongMpy(SInt32 *base,SInt64 max,SInt64 length,SInt32 fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
SInt32 mrLongSum(SInt32 *base,SInt64 max,SInt64 length,SInt32 fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
SInt32 mrrLongSumProd(SInt32 *base,SInt64 max,SInt64 length,SInt32 fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
SInt32 rrLongDiv(SInt64 max,SInt64 length,SInt32 fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
SInt32 rrLongMpy(SInt64 max,SInt64 length,SInt32 fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
SInt32 rrLongSum(SInt64 max,SInt64 length,SInt32 fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
SInt64 mmrSInt64SumProd(SInt64 *base,SInt64 max,SInt64 length,SInt64 fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
SInt64 mrSInt64Div(SInt64 *base,SInt64 max,SInt64 length,SInt64 fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
SInt64 mrSInt64Mpy(SInt64 *base,SInt64 max,SInt64 length,SInt64 fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
SInt64 mrSInt64Sum(SInt64 *base,SInt64 max,SInt64 length,SInt64 fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
SInt64 mrrSInt64SumProd(SInt64 *base,SInt64 max,SInt64 length,SInt64 fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
SInt64 rrSInt64Div(SInt64 max,SInt64 length,SInt64 fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
SInt64 rrSInt64Mpy(SInt64 max,SInt64 length,SInt64 fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
SInt64 rrSInt64Sum(SInt64 max,SInt64 length,SInt64 fdata[],double *bwidth,result *rslt,SInt64 *time_scale);
void fillLongMem(SInt32 *base,SInt64 max,SInt32 ivalue[],SInt32 words);
void fillSInt16Mem(SInt16 * base,SInt64 max,SInt16 ivalue[],SInt32 words);
void fillSInt64Mem(SInt64 *base,SInt64 max,SInt64 ivalue[],SInt32 words);
